MMEvents.createStructures(event => {
    event.create("mm:blood_drainer")
        .controllerId("mm:blood_drainer")
        .name("Blood Drainer")
        .layout(a => {
            a.layer([
                "       ", "       ", "  JJJ  ", "  JMJ  ", "  JJJ  ", "       ", "       "
            ]).layer([
                "       ", " JJJJJ ", " JAAAJ ", " JALAJ ", " JAAAJ ", " JJJJJ ", "       "
            ]).layer([
                "JJJJJJJ", "JAAAAAJ", "JAKKKAJ", "JAKKKAJ", "JAKKKAJ", "JAAAAAJ", "JJJJJJJ"
            ]).layer([
                "       ", " AAAAA ", " F   F ", " F   F ", " F   F ", " AFFFA ", "       "
            ]).layer([
                "       ", " AAAAA ", " F   F ", " F   F ", " F   F ", " AFFFA ", "       "
            ]).layer([
                "       ", " AAAAA ", " FGGGF ", " FGGGF ", " FGGGF ", " AFFFA ", "       "
            ]).layer([
                "       ", " AA3AA ", " ADDDA ", " 1DDD2 ", " ADDDA ", " AAAAA ", "   C   "
            ]).key("A", {
                block: "evilcraft:dark_blood_brick"
            }).key("D", {
                block: "evilcraft:dark_power_gem_block"
            }).key("F", {
                block: "mob_grinding_utils:tinted_glass"
            }).key("G", {
                block: "evilcraft:spiked_plate"
            }).key("J", {
                block: "evilcraft:dark_blood_brick"
            }).key("K", {
                block: "minecraft:netherite_block"
            }).key("L", {
                block: "minecraft:beacon"
            }).key("M", {
                block: "minecraft:red_stained_glass"
            }).key("1", {
                tag: "impostor:item_port_input",
                input: true
            }).key("2", {
                tag: "impostor:fluid_port_output",
                input: false
            }).key("3", {
                tag: "impostor:energy_port_input",
                input: true
            })
        })
})

ServerEvents.recipes(event => {
    // Blood Drainer Controller
    event.shaped('mm:blood_drainer',
        ['DDD', 'DAD', 'DBD'], {
        D: 'evilcraft:dark_power_gem_block',  // Represents dark power and strength
        A: 'minecraft:beacon',                // Central beacon for control
        B: 'evilcraft:spiked_plate'           // For the draining mechanism
    }).id('mm:blood_drainer_controller')
})
